#!/bn/bash

NXServerBac="0.55.55.1"
NetBac="0.55.55.1"

echo "$(whoami)"
echo "----------------------------install  script ---------------------------------------------------------"
if [ -d "/root/PX" ]; then

    # 重要
    sed -i '/\/root\/IPConfig.sh/d' /etc/rc.local
    sed -i '/sudo \/etc\/MAX77961 &/d' /etc/rc.local
   
    echo "Now device PX"
    chmod 777 -R /opt/*

    file_path="/etc/rc.local"
    search_string="restart_server.sh"
    sudo sed -i "/$search_string/d" $file_path
    sudo sed -i '$a\setsid /root/PX/restart_server.sh &' /etc/rc.local

    sudo rm /root/PX/restart_server.sh
    sudo cp /opt/NXServer/shell/PX_restart_server.sh /root/PX/restart_server.sh
    sudo rm /opt/NXServer.zip

    sudo dpkg -i /opt/NXServer/LXI/libkrb5support0_1.16-2ubuntu0.4_arm64.deb
    sudo dpkg -i /opt/NXServer/LXI/libkrb5-3_1.16-2ubuntu0.4_arm64.deb
    sudo dpkg -i /opt/NXServer/LXI/libgssapi-krb5-2_1.16-2ubuntu0.4_arm64.deb
    sudo dpkg -i /opt/NXServer/LXI/libtirpc1_0.2.5-1.2_arm64.deb
    sudo dpkg -i /opt/NXServer/LXI/rpcbind_0.2.3-0.6ubuntu0.18.04.4_arm64.deb

    cd /opt/NXServer/dependency/
    sudo sh install_htraapi_lib.sh

    echo "----------------------------   end ----------------------------------------------------------------------"
    sleep 2
    sudo shutdown -r now

else

    rm /root/NX_update.txt
    echo "Now device NX"

    #Add permissions to the bin directory
    sed -i '/insmod \/lib\/modules\/4.9.170\/mali_kbase.ko/,$d' /etc/init.d/rcS
    echo "insmod /lib/modules/4.9.170/mali_kbase.ko" >> /etc/init.d/rcS
    echo "/usr/local/newbridge.sh" >> /etc/init.d/rcS

    chmod 777 /root/NXServer/bin/ETH_server*
    chmod 777 /root/NXServer/bin/T507_USB_enable
    chmod 777 /root/NXServer/bin/dhclient
    chmod 777 /root/NXServer/bin/arp-scan
    chmod 777 /root/NXServer/bin/NetworkManager*

    chmod 777 -R /root/NXServer/*
    #
    chmod 777 /root/NXServer/uninstall.sh

    #shell directory plus permissions
    # chmod 777 /root/NXServer/shell/restart_server.sh
    chmod 777 /root/NXServer/shell/RestartNet.sh
    chmod 777 /root/NXServer/shell/Fans.sh

    #Configure directory plus permissions
    chmod 777 /root/NXServer/config/dhclient.conf
    chmod 777 /root/NXServer/config/dhclient-script
    chmod 777 /root/NXServer/config/dhcpd.conf

    #Log Catalog
    chmod 777 /root/NXServer/log/restart_info.log
    chmod 777 /root/NXServer/log/NetworkManager.log

    #Copy a file to a specified directory
    cp /root/NXServer/config/dhclient-script /etc/
    cp /root/NXServer/config/dhcpd.conf /etc/
    cp /root/NXServer/bin/dhclient /bin/
    cp /root/NXServer/bin/arp-scan /bin/
    cp /root/NXServer/config/dhclient.conf /etc/
    cp /root/NXServer/config/dhclient.conf /root/NXServer/config/dhclient_copy.conf

    #Configuration of boot scripts
    cp /root/NXServer/shell/NX_restart_server.sh /root/NXServer/restart_server.sh
    file_path="/etc/init.d/rcS"
    search_string="restart_server.sh"
    sed -i "/$search_string/d" $file_path
    sed -i '$a\setsid sh /root/NXServer/restart_server.sh &' /etc/init.d/rcS

    # Assigning values to dhcp configuration scripts Assigning unique addresses
    eth_address=$(ifconfig eth0|grep -o -E '([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})')
    sed -i "2 c send dhcp-client-identifier $eth_address" /root/NXServer/config/dhclient.conf
    cp /root/NXServer/config/dhclient.conf /etc/

    # Create ip cache file for dhcp
    dhLease="/var/db"
    if [ -d "$dhLease" ];then
        if [ -e "/var/db/dhclient.leases" ];then
            continue
        else
            touch /var/db/dhclient.leases
            chmod 777 /var/db/dhclient.leases
        fi
    else
        mkdir $dhLease
        touch /var/db/dhclient.leases
        chmod 777 /var/db/dhclient.leases
    fi


    #Configuration libraries and usb driver files
    chmod 777 /root/NXServer/dependency/install_htraapi_lib.sh
    cd /root/NXServer/dependency
    sh /root/NXServer/dependency/install_htraapi_lib.sh

    rm /root/NXServer.zip
    echo "----------------------------   end ----------------------------------------------------------------------"
    sleep 2
    reboot
fi




