sleep 5


setsid /opt/NXServer/bin/SystemRead > /opt/sys.log

file="/opt/NXServer/config/Device.config"     # 替换为你的文件名
DeviceName="PX"   

sed -i "s/^DeviceType.*/DeviceType=${DeviceName}/" "$file"

echo "SAS success"
echo "install Net"

log="/opt/NXSerer/log/Res.log"
Net="/home/rpdzkj/Net"
v4Config="IPAddr_V4.config"
v4Path="${Net}/${v4Config}"

RUNNING_INSTANCES=$(ps -ef | grep Res_ | grep -v grep)

INSTANCE_COUNT=$(echo "$RUNNING_INSTANCES" | wc -l)

if [ "$INSTANCE_COUNT" -gt 2 ]; then
#   echo "检测到多个脚本实例正在运行，退出。"
  exit 1
fi


while true
do
	sleep 1

	ETH_RUN=$(ps -ef | grep ETH | grep -v grep | awk '{print $2}')
	NetLo=$(ifconfig | grep UP | awk -F': ' '{print $1}' | grep -v lo)

	# echo "eth_run $ETH_RUN ---1"

	if [ -z "$NetLo" ]; then
		
		sleep 0.5
		if [ -n "$ETH_RUN" ]; then
			sleep 0.1
		else
			kill $ETH_RUN
		fi
		echo "log Waing : net close" >> $log
		sudo  ip addr flush dev $NetLo
	else

		NetConnect=$(ifconfig $NetLo| grep RUNNING)	
		
		# echo "NetConnect $NetConnect ---2"
		
		if [ -z "$NetConnect" ]; then
			if [ -n "$ETH_RUN" ]; then
				sleep 0.1
			else
				kill $ETH_RUN
			fi

			sudo  ip addr flush dev $NetLo
			echo "ip addr flush dev" >> $log
		else
			sleep 3
			net=$(ifconfig $NetLo | grep netmask)

			if [ -z "$net" ]; then
  				sudo  route add -host 255.255.255.255 dev $NetLo
  				sleep 0.5
				sudo  ps -ef | grep Net | grep -v grep | awk '{print $2}' | xargs kill -9
				if [ -f "/home/rpdzkj/Net/IPAddr_V4.config" ]; then
						echo "into"
						echo $v4Path
						while IFS= read -r line || [ -n "$line" ]
						do
						echo "Line read: $line"
						sudo  ip addr add "$line" dev "$NetLo"
						if [ $? -ne 0 ]; then
							echo "Failed to add IP address: $line"
						fi
						done < "$v4Path"
						echo "ip addr add dev" >> $log
				else
					sudo  ip addr add 192.168.1.100/24 dev "$NetLo"
				fi
				sudo arp-scan --localnet
			fi

			sudo arp-scan --localnet

			ETH_RUN=$(ps -ef | grep ETH | grep -v grep | awk '{print $2}')

			if [ -n "$ETH_RUN" ];then
				sleep 0.1
			else
				sudo /opt/NXServer/bin/ETH_server* &
			fi

			VXI=$(ps -ef | grep VXI_Server | grep -v grep | awk '{print $2}')

			if [ -n "$VXI" ];then
				sleep 0.1
			else
				sudo /opt/NXServer/bin/VXI_Server* >> /opt/NXServer/log/VXI.log &
			fi

			PXConfig_zi=$(ls /opt | grep .*PXConfig.\*.zip)

			echo ${PXConfig_zi}

			if [ -f "/opt/PX_update.txt" ]; then

				old_PXConfig=$(ls /opt | grep -v .*PXConfig.\*.zip | grep -v .*PXConfig.\*.deb | grep .*PXConfig.\*)
			
				echo ${old_PXConfig}
				# sudo rm -r /opt/${old_PXConfig}

				sudo mv /opt/${old_PXConfig}  /opt/oldConfig

				sudo unzip /opt/${PXConfig_zi} -d /opt/
				
				new_PXConfig=$(ls /opt | grep -v .*PXConfig.\*.zip | grep .*PXConfig.\*)

				sudo sh /opt/${new_PXConfig}/update.sh

				sudo rm /opt/${PXConfig_zi}

				sleep 1
			fi

			if [ -f "/root/NX_update.txt" ]; then
				kill -9 $ETH_RUN
				# 添加执行权限
				sudo rm -r /opt/NXServer/

				sudo unzip -o /opt/NXServer.zip -d /opt/ 

				sudo setsid sh /opt/NXServer/update.sh &
				
				sleep 1
				sudo rm /opt/NXServer.zip
				exit 0
			fi
		fi
	fi
done
