#!/bin/bash
NXServerBac="0.55.55.1"
NetBac="0.55.55.1"

if [ -d "/root/PX" ]; then
    sudo chmod 777 -R /opt/*
    sudo rm /root/PX/restart_server.sh
    sudo cp /opt/NXServer/shell/PX_restart_server.sh /root/PX/restart_server.sh

    new_PXConfig=$(ls /opt | grep -v .*PXConfig.\*.zip | grep -v .*PXConfig.\*.deb | grep .*PXConfig.\*)
    sudo cp -r /opt/${new_PXConfig}/CalFile/* /opt/NXServer/bin/CalFile

    sudo dpkg -i /opt/NXServer/LXI/libkrb5support0_1.16-2ubuntu0.4_arm64.deb
    sudo dpkg -i /opt/NXServer/LXI/libkrb5-3_1.16-2ubuntu0.4_arm64.deb
    sudo dpkg -i /opt/NXServer/LXI/libgssapi-krb5-2_1.16-2ubuntu0.4_arm64.deb
    sudo dpkg -i /opt/NXServer/LXI/libtirpc1_0.2.5-1.2_arm64.deb
    sudo dpkg -i /opt/NXServer/LXI/rpcbind_0.2.3-0.6ubuntu0.18.04.4_arm64.deb

    cd /opt/NXServer/dependency/
    sudo sh install_htraapi_lib.sh

    sleep 1

    rm /root/NX_update.txt

    sudo setsid /root/PX/restart_server.sh &
else

    chmod 777 -R /root/NXServer/*


    #Copy a file to a specified directory
    cp /root/NXServer/config/dhclient-script /etc/
    cp /root/NXServer/config/dhcpd.conf /etc/
    cp /root/NXServer/bin/dhclient /bin/
    cp /root/NXServer/bin/arp-scan /bin/
    cp /root/NXServer/config/dhclient.conf /etc/
    cp /root/NXServer/config/dhclient.conf /root/NXServer/config/dhclient_copy.conf

    Net="NetworkManager"

    NetworkRun=`ps | grep $Net | grep -v grep | sed 's/^\s*//' | sed 's/[[:space:]].*//'`
    
    ETH_RUN=`ps | grep ETH | grep -v grep | sed 's/^\s*//' | sed 's/[[:space:]].*//'`

    kill -9 $Net
    kill -9 $NetworkRun

    #Configuration of boot scripts
    cp /root/NXServer/shell/NX_restart_server.sh /root/NXServer/restart_server.sh
    file_path="/etc/init.d/rcS"
    search_string="restart_server.sh"
    sed -i "/$search_string/d" $file_path
    sed -i '$a\setsid sh /root/NXServer/restart_server.sh &' /etc/init.d/rcS

    # Assigning values to dhcp configuration scripts Assigning unique addresses
    eth_address=$(ifconfig eth0|grep -o -E '([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})')
    sed -i "2 c send dhcp-client-identifier $eth_address" /root/NXServer/config/dhclient.conf
    cp /root/NXServer/config/dhclient.conf /etc/

    # Create ip cache file for dhcp
    dhLease="/var/db"
    if [ -d "$dhLease" ];then
        if [ -e "/var/db/dhclient.leases" ];then
            continue
        else
            touch /var/db/dhclient.leases
            chmod 777 /var/db/dhclient.leases
        fi
    else
        mkdir $dhLease
        touch /var/db/dhclient.leases
        chmod 777 /var/db/dhclient.leases
    fi


    #Configuration libraries and usb driver files
    chmod 777 /root/NXServer/dependency/install_htraapi_lib.sh
    cd /root/NXServer/dependency
    sh /root/NXServer/dependency/install_htraapi_lib.sh
    
    rm /root/NX_update.txt

    sleep 2
    setsid /root/NXServer/restart_server.sh "1" &
fi




#  /shengchan/NX/Bac
#  /ProcessEquipment/Updater/55/Update.zip
#
#